/*
 * see sensed.c for details & licensing 
 */

static inline int getbitfield (unsigned char *pageaddr, int mask, int shift) 
{
  return ((*pageaddr >> shift) & mask);
}

/*
 * This is where you define the command that has to be sent to your scanner
 * and how to interpret the return data.
 * 
 * As-is, it works with the Fujitsu M3091DCd scanner. Your Mileage May Vary.
 */

static unsigned char requestSenseCommand[] = { 0x03, 0x00, 0x00, 0x00, 0x00, 0x00};

#define setSenseAllocationLength(buffer, n) buffer[0x04] = n;
#define getSenseInfoValid(buffer)           getbitfield(buffer + 0x00, 1, 7)
#define getSenseErrorCode(buffer)           getbitfield(buffer + 0x00, 0x7f, 0)
#define getSenseFileMark(buffer)            getbitfield(buffer + 0x02, 1, 7)
#define getSenseEOM(buffer)                 getbitfield(buffer + 0x02, 1, 6)
#define getSenseILI(buffer)                 getbitfield(buffer + 0x02, 1, 5)
#define getSenseKey(buffer)                 getbitfield(buffer + 0x02, 0x0f, 0)
#define getSenseAdditionalLength(buffer)    buffer[0x07]
#define getSenseASC(buffer)                 buffer[0x0c]
#define getSenseASCQ(buffer)                buffer[0x0d]
#define getSenseADFHasPaper(buffer)         getbitfield (buffer + 0x0d, 1, 0)
#define getSensePaperEdgeHasPaper(buffer)   getbitfield (buffer + 0x0d, 1, 1)
#define getSenseDuplexButtonStatus(buffer)  getbitfield (buffer + 0x0d, 1, 2)
#define getSenseScanButtonStatus(buffer)    getbitfield (buffer + 0x0d, 1, 4)
#define getSenseSendButtonStatus(buffer)    getbitfield (buffer + 0x0d, 1, 5)
#define getSenseCoverOpen(buffer)           getbitfield (buffer + 0x0d, 1, 7)
#define getSenseDensityDialSetting(buffer)  getbitfield (buffer + 0x0f, 7, 0)
#define getSenseNumberOfCopies(buffer)      getbitfield (buffer + 0x0f, 15, 3)
#define getSenseSKSV(buffer)                getbitfield (buffer+0x0f,1,7)

